package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketCodeLog;
import com.izouma.awesomeadmin.service.MarketCodeLogService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketCodeLog")
public class MarketCodeLogController {

    @Autowired
    private MarketCodeLogService marketCodeLogService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketCodeLog record) {
        List<MarketCodeLog> pp = marketCodeLogService.getMarketCodeLogList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketCodeLog", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketCodeLog(@RequestParam(required = false, value = "id") String id) {
        MarketCodeLog data = marketCodeLogService.getMarketCodeLogById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketCodeLog record) {
        MarketCodeLog data = marketCodeLogService.getMarketCodeLog(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketCodeLog record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketCodeLog> pp =marketCodeLogService.getMarketCodeLogByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketCodeLog record) {
        boolean num = marketCodeLogService.createMarketCodeLog(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketCodeLog(MarketCodeLog record) {
        boolean num = marketCodeLogService.updateMarketCodeLog(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketCodeLog(MarketCodeLog record) {

        boolean num = marketCodeLogService.deleteMarketCodeLog(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketCodeLog record) throws Exception {

    List<MarketCodeLog> marketCodeLogs = marketCodeLogService.getMarketCodeLogList(record);


        String sheetName = "market_code_log";
        String titleName = "推广码记录数据表";
        String fileName = "推广码记录表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户ID" ,   "推广码" ,   "推广用户" ,   "价格" ,   "备注"  };
        String[][] dataList = new String[marketCodeLogs.size()][11];

        for (int i = 0; i < marketCodeLogs.size(); i++) {

                        dataList[i][0] = String.valueOf(marketCodeLogs.get(i).getId());
                        dataList[i][1] = String.valueOf(marketCodeLogs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketCodeLogs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketCodeLogs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketCodeLogs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketCodeLogs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketCodeLogs.get(i).getUserId());
                        dataList[i][7] = String.valueOf(marketCodeLogs.get(i).getMarketCode());
                        dataList[i][8] = String.valueOf(marketCodeLogs.get(i).getMarketUserId());
                        dataList[i][9] = String.valueOf(marketCodeLogs.get(i).getTotalPrice());
                        dataList[i][10] = String.valueOf(marketCodeLogs.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

